
#include <ArduinoBLE.h>

char* PERIPHERAL_LOCAL_NAME = "Peripheral SPS30 BLE";
#define BLE_UUID_SENSOR_DATA_SERVICE    "19B10030-E8F2-537E-4F6C-D104768A1214"
#define BLE_UUID_MULTI_SENSOR_DATA      "19B10032-E8F2-537E-4F6C-D104768A1214"

#define BAUDRATE                        115200
#define UPDATE_INTERVALL                10
#define BLE_POLL_INTERVALL              5
long loopcount = 0 ;
BLEDevice peripheral;    

uint64_t previousMillis = 0;
bool DoScan = true;

void setup() {
    
    Serial.begin(BAUDRATE);
    delay(2000);
    
    previousMillis = millis();

    BLE.begin();

    while (Serial.available()){
      Serial.read();
      delay(100); 
    }
}

void loop() {
    unsigned long currentMillis = millis();
    
    if (currentMillis - previousMillis > UPDATE_INTERVALL) {
        
    previousMillis = currentMillis;  

    // do not scan all the time in the loop to protect HCI-layer
    if (DoScan) {
      Serial.println("set scan \n");
      BLE.scanForUuid(BLE_UUID_SENSOR_DATA_SERVICE, true);
      DoScan = false;
    }
    
    if(loopcount++ > 400) {
      
      if (Serial.available()){    // if enter is pressed trigger manual scan in case it stopped, 
        
        delay(100);               // empty anything pending
        while (Serial.available()){
          Serial.read();
          delay(100); 
        }
        
        DoScan = true;            // scan next loop
      }
    
      loopcount=0;                // reset loopcount for next check
    } 
           
    BLE.poll();
    
    peripheral = BLE.available();
          

    if (peripheral) {
        
        Serial.println("peripheral");         
        
        if (peripheral.localName() != PERIPHERAL_LOCAL_NAME) {
            return;
        }

        BLE.stopScan();

        explorePeripheral(peripheral);

        DoScan = true;
    }
  }
}

bool explorePeripheral(BLEDevice peripheral) {
    
    if (!peripheral.connect()) {
        return false;
    }
  
    if (!peripheral.discoverAttributes()) {
        peripheral.disconnect();
        return false;
    }
  
    BLECharacteristic multiSensorDataCharacteristic = peripheral.characteristic(BLE_UUID_MULTI_SENSOR_DATA);
    if (!multiSensorDataCharacteristic) {
      Serial.println("found char");
        peripheral.disconnect();
        return false;
    }
    
    if (!multiSensorDataCharacteristic.canSubscribe()) {
            Serial.println("can not sub");
        peripheral.disconnect();
        return false;
    }
    
    if (!multiSensorDataCharacteristic.subscribe()) {
           Serial.println("can not sub2");
        peripheral.disconnect();
        return false;
    }
  
    while (peripheral.connected()) { 
            Serial.println("connected");
        unsigned long currentMillis = millis();
        
        if (currentMillis - previousMillis > BLE_POLL_INTERVALL) {

            previousMillis = currentMillis;
                    Serial.println("poll");
            BLE.poll();

            if (multiSensorDataCharacteristic.valueUpdated()) {
            Serial.println("got values");
            delay(2000);
            //break;
               // multiSensorDataCharacteristic.readValue(...);
            }

            // if (peripheral.rssi() != 0) {
            //     digitalWrite(RSSI_OK_LED_PIN, HIGH);
            // } else {
            //     digitalWrite(RSSI_OK_LED_PIN, LOW); // red alarm LED ON
            // }
        }
    }
Serial.println("got disconnect");
    peripheral.disconnect();
    return true;
}
